// StudentGPA.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "StudentGPA.h"
#include <time.h>
#include <fstream>
#include <afxtempl.h>
#include <cstdlib>
#include "GradeRecord.h"
#include "HighResolutionTime.h"

char* cacheFile = "cacheFile";

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object
CWinApp theApp;

// List of all student grade records
CList <CGradeRecord, CGradeRecord&> studentList;

void displayMenu();
void gpaBySSN();
void gpaByLastName();
void gpaByCourseId();
HighResolutionTime t;

CDatabase db;

using namespace std;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// Error!  This should never happen
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}

	//////////////////////////////////////////
	// This is where the real program starts
	//////////////////////////////////////////
	else
	{
		//////////////////////////////////////
		// CONNECT TO DATABASE
		/////////////////////////////////////
		BOOL result = db.Open(NULL,FALSE,FALSE,
							  _T("ODBC;DSN=CS325;UID=SCOTT;PWD=TIGER;"),
							  TRUE);

		if (!result) {
			cout << "Database Connection failed." << endl;
			exit(0);
		}

		//////////////////////////////////////
		// MENU
		/////////////////////////////////////
		displayMenu();
	}

	// Exit
	cout << "Press enter to terminate..." << endl;
	char c;
	cin.get(c);
	return nRetCode;
}

void displayMenu()
{
	while (true) {
		system("cls");
		cout << "Welcome to the Stonehill Student GPA Application" << endl;
		cout << endl;
		cout << "Select one of the following" << endl;
		cout << "----- Main Menu -----" << endl;
		cout << endl;
		cout << "1) GPA by SSN" << endl;
		cout << "2) GPA by Last Name" << endl;
		cout << "3) GPA by CourseID" << endl;
		cout << endl;
		cout << "0) Exit" << endl;
		cout << endl;
		cout << endl;
		cout << ">";

		char c;
		cin >> c;

		switch (c)
		{
			case '0':
				return;
				break;

			case '1':
				gpaBySSN();
				break;

			case '2':
				gpaByLastName();
				break;

			case '3':
				gpaByCourseId();
				break;

		}
	}
}

void gpaByLastName()
{
	string lname;
	char c;

	cout << "Enter student last name: " << endl;
	cin  >> lname;
	cin.get(c);

	CRecordset rs( &db );

	CString g = "SELECT student.ssn, last, avg(grade) from student,grade where student.last='";
	g += lname.c_str();
	g += "' and student.ssn=grade.ssn group by student.ssn, last";

	rs.Open( CRecordset::forwardOnly, g);	

	if (rs.IsEOF()) {
		cout << "Record not found!" << endl;
	}
	else {
		CDBVariant ssn;
		CDBVariant last;
		CDBVariant grade;

		rs.GetFieldValue("SSN", ssn);
		rs.GetFieldValue("LAST", last);
		rs.GetFieldValue("AVG(GRADE)", grade );
	
		cout << (LPCTSTR) *ssn.m_pstring 
			 << " "
			 << (LPCTSTR) *last.m_pstring 
			 << " "
		     << grade.m_dblVal << endl; 
	}
	
	rs.Close();

	cout << "Press enter to continue..." << endl;
	cin.get(c);
}

void gpaBySSN()
{
	string ssn;
	char c;

	cout << "Enter student SSN: " << endl;
	cin  >> ssn;
	cin.get(c);

	// CRecordset
	CRecordset rs( &db );

	CString s = "SELECT first, last from student where ssn='";
	s += ssn.c_str();
	s += "'";

	rs.Open( CRecordset::forwardOnly, s );

	if (rs.IsEOF()) {
		cout << "Record not found!" << endl;
	}
	else {

		CDBVariant fname;
		CDBVariant lname;

		rs.GetFieldValue("FIRST", fname);
		rs.GetFieldValue("LAST", lname);

		cout << (LPCTSTR) *fname.m_pstring 
			 << " "
		     << (LPCTSTR) *lname.m_pstring 
			 << " ";
	}

	rs.Close();

	CString g = "SELECT avg(grade) from grade where ssn='";
	g += ssn.c_str();
	g += "'";

	rs.Open( CRecordset::forwardOnly, g);

	if (rs.IsEOF()) {
		cout << "Record not found!" << endl;
	}
	else {
		CDBVariant grade;
		
		rs.GetFieldValue("AVG(GRADE)", grade );

		cout << grade.m_dblVal << endl; 
	}

	rs.Close();

	/*
    CString g = "SELECT first, last, AVG(GRADE) from student,grade where student.ssn='";
	g += ssn.c_str();
	g += "' and student.ssn=grade.ssn group by first, last";

	rs.Open( CRecordset::forwardOnly, g);	

	if (rs.IsEOF()) {
		cout << "Record not found!" << endl;
	}
	else {
		CDBVariant grade;
		CDBVariant fname;
		CDBVariant lname;

		rs.GetFieldValue("FIRST", fname);
		rs.GetFieldValue("LAST", lname);
		rs.GetFieldValue("AVG(GRADE)", grade );
	
		cout << (LPCTSTR) *fname.m_pstring 
			 << " "
		     << (LPCTSTR) *lname.m_pstring 
			 << " ";
		cout << grade.m_dblVal << endl; 
	}

	rs.Close();
    */

	cout << "Press enter to continue..." << endl;
	cin.get(c);
}


void gpaByCourseId()
{
	string courseId;
	char c;

	cout << "Enter student course id (ccNNN): " << endl;
	cin  >> courseId;
	cin.get(c);

	CRecordset rs( &db );

	CString g = "SELECT name, avg(grade) from course,grade where course.id='";
	g += courseId.c_str();
	g += "' and course.id=grade.id group by name";

	rs.Open( CRecordset::forwardOnly, g);	

	if (rs.IsEOF()) {
		cout << "Record not found!" << endl;
	}
	else {
		CDBVariant grade;
		CDBVariant cname;

		rs.GetFieldValue("NAME", cname);
		rs.GetFieldValue("AVG(GRADE)", grade );
	
		cout << (LPCTSTR) *cname.m_pstring 
			 << " "
		     << grade.m_dblVal << endl; 
	}
	
	rs.Close();

	cout << "Press enter to continue..." << endl;
	cin.get(c);
}